/************************************************
* KBSETUP - set the desired delay/repeat rate	*
* for the keyboard.								*
*												*
* With no arguments, it speeds up the keyboard	*
* to the fastest possible rate.					*
************************************************/

#include <ctype.h>	/* isdigit, tolower			*/
#include <dos.h>	/* geninterrupt				*/
#include <stdio.h>
#include <stdlib.h>

#define ISIN(l,h,v) ((l<=v)&&(v<=h))

int kbdelay=0,		/* Default typematic delay	*/
	kbrepeat=0;		/* Default repeat rate		*/

void usage(void)
	{
	puts("KBSETUP ERROR: two types of parameters"
		 "are allowed.\nA, B, C or D will set th"
		 "e delay before repeating to 1/4, 1/2, "
		 "3/4 and 1 second,\nRespectively.  The "
		 "numbers from 0..31 set the repeat rate"
		 " of the keyboard.");
	exit(1);
	}

void main(int argc, char *argv[])
	{
	int i;
	/* Process the arguments */
	for (i=1; i<argc; ++i)
		if (isdigit(*argv[i]))	/* repeat rate	*/
			{
			kbrepeat=atoi(argv[i]);
			if (!ISIN(0,31,kbrepeat))
				usage();
			}
		else				/* delay before rpt	*/
			{
			argv[i][0]=toupper(argv[i][0]);
			if (!ISIN('A','D',argv[i][0]))
				usage();
			kbdelay=argv[i][0]-'A';
			}

	/* Set the keyboard delay/repeat rate */
	_AX=0x0305;
	_BH=kbdelay;
	_BL=kbrepeat;
	geninterrupt(0x16);
	}
