/************************************************
* QUEEN3 - the third attempt at solving the		*
* queens problem.								*
*												*
* INP:	c - the column # to place a queen in	*
*		n - the maximum column (& row) number	*
* USES:	Soln - updates this solution counter	*
*		whenever a queen is successfully placed	*
*		in the n'th column.						*
************************************************/

#define TRUE   (1==1)	/* Boolean true value	*/
#define FALSE  (1==0)	/* Boolean false value	*/
#define MAXBRD 25		/* Maximum board size	*/

void PrintBoard(int);
void queens(int c, int n)
	{
	extern int  board[MAXBRD+1][MAXBRD+1];
	extern long Solns;
	int i,j,k,legal;

	/* Have we found a solution? */
	if (c==n)
		{
		++Solns;
		return;
		}

	/* Check each spot in the column */
	for (i=0; i<n; i++)
		{
		/* Is square attacked by other queen?	*/
		if (board[i][c] == 0)
			{
			/* No: take this square, and mark	*/
			/* all attacked squares to the right*/
			board[i][c] = -1;
			for (k=1,j=c+1; j<n; j++,k++)
				{
				board[i][j]++;	/* On same row	*/
				if (i+k<n)		/* On + diagonal*/
					board[i+k][j]++;
				if (i-k>=0)		/* On - diagonal*/
					board[i-k][j]++;
				}

			/* Now, compute rest of solution	*/
			queens(c+1,n);

			/* Unmark this square, & all squares*/
			/* attacked by this queen			*/
			board[i][c] = 0;
			for (k=1,j=c+1; j<n; j++,k++)
				{
				board[i][j]--;	/* On same row	*/
				if (i+k<n)		/* On + diagonal*/
					board[i+k][j]--;
				if (i-k>=0)		/* On - diagonal*/
					board[i-k][j]--;
				}
			}
		}
	}
